# TODO: vmaf
#
# Conditional build:
%bcond_without	asm	# x86 assembler
%bcond_with	vmaf	# VMAF support [not ready for 1.3.9]

%ifnarch %{ix86} %{x8664} x32
%undefine	with_asm
%endif

Summary:	H.265/HEVC video encoder
Summary(pl.UTF-8):	Koder obrazu H.265/HEVC
Name:		x265
Version:	2.9
Release:	1
License:	GPL v2+
Group:		Libraries
# also at https://bitbucket.org/multicoreware/x265/downloads
Source0:	http://ftp.videolan.org/pub/videolan/x265/%{name}_%{version}.tar.gz
# Source0-md5:	693ee4ce7929a59735f441107310f0bb
Patch0:		%{name}-opt.patch
Patch1:		%{name}-x32.patch
URL:		http://x265.org/
BuildRequires:	cmake >= 2.8.11
BuildRequires:	libstdc++-devel >= 6:4.8
BuildRequires:	numactl-devel >= 2
BuildRequires:	rpmbuild(macros) >= 1.605
%{?with_asm:BuildRequires:	nasm >= 2.13.0}
%{?with_vmaf:BuildRequires:	vmaf-devel}
Requires:	libx265 = %{version}-%{release}
# see CMakeLists.txt, more is probably possible
ExclusiveArch:	%{ix86} %{x8664} x32 %{arm} ppc64 ppc64le
# needs 64-bit atomic compare and swap
ExcludeArch:	i386 i486
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
H.265/HEVC video encoder.

%description -l pl.UTF-8
Koder obrazu H.265/HEVC.

%package -n libx265
Summary:	H.265/HEVC video encoder library
Summary(pl.UTF-8):	Biblioteka kodowania obrazu H.265/HEVC
Group:		Libraries

%description -n libx265
H.265/HEVC video encoder library.

%description -n libx265 -l pl.UTF-8
Biblioteka kodowania obrazu H.265/HEVC.

%package -n libx265-devel
Summary:	Header files for x265 library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki x265
Group:		Development/Libraries
Requires:	libstdc++-devel >= 6:4.8
Requires:	libx265 = %{version}-%{release}
Requires:	numactl-devel >= 2

%description -n libx265-devel
Header files for x265 library.

%description -n libx265-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki x265.

%package -n libx265-static
Summary:	Static x265 library
Summary(pl.UTF-8):	Statyczna biblioteka x265
Group:		Development/Libraries
Requires:	libx265-devel = %{version}-%{release}

%description -n libx265-static
Static x265 library.

%description -n libx265-static -l pl.UTF-8
Statyczna biblioteka x265.

%prep
%setup -q -n %{name}_%{version}
%patch0 -p1
%patch1 -p1

%build
install -d source/build
cd source/build
%cmake .. \
	-DENABLE_ASSEMBLY=%{!?with_asm:OFF}%{?with_asm:ON} \
	-DENABLE_HDR10_PLUS=ON \
	%{?with_vmaf:-DENABLE_LIBVMAF=ON} \
	-DENABLE_SHARED=ON \
	-DLIB_INSTALL_DIR=%{_lib}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} -C source/build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-n libx265 -p /sbin/ldconfig
%postun	-n libx265 -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc doc/reST/cli.rst
%attr(755,root,root) %{_bindir}/x265

%files -n libx265
%defattr(644,root,root,755)
%doc doc/reST/introduction.rst
%attr(755,root,root) %{_libdir}/libx265.so.165
%attr(755,root,root) %{_libdir}/libhdr10plus.so

%files -n libx265-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libx265.so
%{_includedir}/hdr10plus.h
%{_includedir}/x265.h
%{_includedir}/x265_config.h
%{_pkgconfigdir}/x265.pc

%files -n libx265-static
%defattr(644,root,root,755)
%{_libdir}/libhdr10plus.a
%{_libdir}/libx265.a
%changelog
* Tue Nov 20 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/x265.git;a=log;h=master

* Wed Oct 31 2018 Jakub Bogusz <qboosh@pld-linux.org> 5afc8bc
- updated to 2.9 (note: new soname)
- updated x32 patch

* Sat Dec 23 2017 Jakub Bogusz <qboosh@pld-linux.org> 1d3acdc
- updated to 2.6 (note: new soname)

* Sun Jul 16 2017 Jakub Bogusz <qboosh@pld-linux.org> a827c98
- updated to 2.5 (ABI 130)

* Wed May 24 2017 Jakub Bogusz <qboosh@pld-linux.org> a8d1efd
- updated to 2.4 (note: new soname, ABI 116)

* Sat Oct 08 2016 Jakub Bogusz <qboosh@pld-linux.org> dcd66c3
- updated to 2.1 (note: new soname)

* Sat Feb 20 2016 Jakub Bogusz <qboosh@pld-linux.org> 52bf8e6
- updated to 1.9 (note: new soname)

* Thu Oct 15 2015 Jakub Bogusz <qboosh@pld-linux.org> c14ed13
- added x32 patch, asm could be enabled on x32 now

* Wed Oct 14 2015 Jakub Bogusz <qboosh@pld-linux.org> 940d1e5
- updated to 1.8 (note: new soname, ABI 68)

* Thu Sep 17 2015 Jakub Bogusz <qboosh@pld-linux.org> b240e31
- BR: numactl-devel

* Mon Sep 14 2015 Elan Ruusamäe <glen@delfi.ee> 29378b7
- up to 1.7 stable, NOTE: soname change

* Wed Jun 10 2015 Elan Ruusamäe <glen@delfi.ee> 6277aac
- simplify: add asm bcond

* Wed Jun 10 2015 Elan Ruusamäe <glen@delfi.ee> 26e9942
- builds on x32 without asm

* Wed Jun 10 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 80d4b5b
- up to 20150610

* Thu May 28 2015 Elan Ruusamäe <glen@delfi.ee> b27c95f
- add rel macro for scripting

* Thu May 28 2015 Marcin Krol <hawk@tld-linux.org> e58c100
- release 3

* Tue Aug 26 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> be2fe8d
- rel .2

* Tue Aug 26 2014 Jakub Bogusz <qboosh@pld-linux.org> 7b54826
- pass relative LIB_INSTALL_DIR to get correct libdir in .pc file
- use out of source build

* Mon Aug 25 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> a3a5561
- up to 1.3 20140825

* Sat Mar 29 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 528852c
- rel .2; fix -devel R in -static subpkg

* Sat Mar 29 2014 Jakub Bogusz <qboosh@pld-linux.org> a3d1003
- added libdir patch (fixes build on lib64 systems)
- exclude i[34]86 because of 64-bit atomic compare and swap instructions

